#!/usr/bin/python

import intermediary_language as il
import nesc_interface as nesC
import os
from pdb import set_trace as st
import pickle
import sys

# util

#  0  1  2  3  4  5  6  7  8  9 10 11 12 13
# 0B 00 0A 00 00 00 7E 00 6D 7D 01 00 0A 01 00 00 00 00 00 01 00
# 0D 00 0A 00 00 00 7E 00 6D 7D 01 00 09 00 00 01 00 00 00 00 00 01 00 
# 09 00 0A 00 00 00 7E 00 6D 7D 01 00 0B 01 00 00 00 01 00 
# 09 00 0A 00 00 00 7E 00 6D 7D 01 00 0C 01 00 00 00 01 00 
# 0B 00 0A 00 00 00 7E 00 6D 7D 01 00 04 01 00 00 00 00 00 01 00 
# 0D 00 0A 00 00 00 7E 00 6D 7D 01 00 06 01 00 01 00 00 00 00 00 0B 00 
# 0B 00 0A 00 00 00 7E 00 6D 7D 01 00 02 00 00 01 00 00 00 0B 00 

class MsgField: # note: strong nesc dependency in RtMsgs.h
	def __init__(self,offset,name):
		self.offset = offset
		self.name = name

# consts

PKL_TUPLEMSG = '.pkl_tuplemsg'
FLAT_TUPLEMSG = '.flat_tuplemsg'


TUPLE_MSG_FORMAT = (MsgField(10,'Source Address'),
										MsgField(12,'Tuple Type'),
										MsgField(13,'Data'))

# store stuff

class TupleMsgStore:
	def __init__(self, symboltable, outdir):
		self._symboltable = symboltable;
		self._outdir = outdir;		
	def generatebypickle(self):
		f = open(os.path.join(self._outdir,PKL_TUPLEMSG),'w')
		p = pickle.Pickler(f)
		p.dump(self._symboltable)
	def generate(self):
		f = open(os.path.join(self._outdir,FLAT_TUPLEMSG),'w')
		for p in self._symboltable.symbols:
			if not isinstance(p,nesC.Predicate):
				continue
			if p.temporary: #or p.primary 
				continue
			offset_array = ''
			total_size = 0
			for i,c in enumerate(p.columns):
				if i == 0:
					offset_array += '0'
				else:
					offset_array += ','+str(total_size)
				total_size += c.size 
			print >>f, p.name, p.id, offset_array

def generate(symboltable, plan, facts, outdir=None):
	tms = TupleMsgStore(symboltable,outdir)
	tms.generate()

# load stuff

class TupleMsgParser:
	def __init__(self, outdir):
		self._symboltable = None;
		self._outdir = outdir;		
		f = open(os.path.join(self._outdir,PKL_TUPLEMSG),'r')
		self._symboltable = pickle.load(f)
	def parse(self,msgbytes):
		
		pass

def main():
	tmp = TupleMsgParser('/home/davidchu/projects/sdlib/new/decsn/code/gen') # fix me

if __name__ == '__main__': main()







# # simple illustration client/server pair; client program sends a string
# # to server, which echoes it back to the client (in multiple copies),
# # and the latter prints to the screen

# # this is the client

# import socket
# import sys

# # create a socket
# s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

# # connect to server
# host = sys.argv[1] # server address
# port = int(sys.argv[2]) # server port
# s.connect((host, port))

# s.send(sys.argv[3]) # send test string

# # read echo
# i = 0
# while(1):
# 	data = s.recv(1000000) # read up to 1000000 bytes
# 	i += 1
# 	if (i < 5):
# 		print data
# 	if not data: # if end of data, leave loop
# 		break
# 	print received, len(data), bytes

# # close the connection
# s.close()
