#ifndef __DSN_DEBUG__
#define __DSN_DEBUG__

#include "SPSimDbg.h"
  
/* not defining paramchk will disable assert-like parameter
	 checking. these are usually found in conjunction with error exits.
	 It's nice to enable these when testing and debugging, and disable
	 them when in production or counting code size.  Ideally, our
	 compiler should never issue anything that permits an error_exit
	 state :-0 */

#define PARAMCHK 1

/* strict may make some programs we currently have written fail!  In
	 particular, aggregation which does "out-of-table" memory allocation
	 will fail */
/* #define PARAMCHK_STRICT 1 */

#define UART_DEBUG 1

#ifndef ERROR_CODE_TYPE
#define ERROR_CODE_TYPE uint16_t
#endif

#ifdef UART_DEBUG
uint16_t _uart_seqno_ = 0x7777;
bool _uart_lock_ = FALSE;

typedef struct DebugMsg_t {
  uint16_t addr;
  uint16_t type;
  uint16_t seqno;
  uint8_t data[0]; // need to unwrap on my own
} DebugMsg_t;

enum {
  AM_UARTDEBUGMSG = 108, // if you change this value, manually change value in java.dsntools.Listen2 or die!
  AM_UART_ERROR_EXIT = 19
};

#endif


#define TABLE_DEBUG 0x8000

/* disabled by default because it adds a timer per relation */
/* #define ENABLE_GARBAGE_COLLECTOR 1 */

#endif /*__DSN_DEBUG__*/
