#ifndef __SPSIMDBG_H
#define __SPSIMDBG_H

#include "SPSimDbgCommon.h"

#define assert(w)
#define fail(reason)

#define printdnnl(mode,fmt,...)
#define printd(mode,fmt,...)
#define printf(fmt,...)

#define hexdump(p, len)

/* violation and segault defines */
#define ERROR_EXIT(...) call Leds.set(7); atomic {for(;;);} return __VA_ARGS__;
//#define ERROR_EXIT(...) return __VA_ARGS__;

/* #define USE_UART_ERROR_EXIT */
//this is the type of the code from ERROR_EXIT_UART
//NOTE: if you change this also change the definition from ErrorExit interface
#define ERROR_CODE_TYPE uint16_t
#ifdef USE_UART_ERROR_EXIT 
#define ERROR_EXIT_UART(code,pointer,len) call ErrorExit.Exit(code,pointer,len); return 1;
#else
#define ERROR_EXIT_UART(code,pointer,len) ;//DO NOTHING FOR ERROR_EXIT_UART
#endif

/*
 * Some stats on calling Leds.set and atomic {for(;;);} for telosb and trickle:
 * 36588 bytes in ROM: Leds and atomic for
 * 35062 bytes in ROM: Leds only 
 * 34074 bytes in ROM: neither
 * unfortunately the msp430 exit() in stdlib.h doesn't include correctly - reason unclear
 */

#define SILENT_EXIT(...) atomic {for(;;);} return __VA_ARGS__;
#define LEXIT(n,...) call Leds.set(n); atomic {for(;;);} return __VA_ARGS__;
#define LSET(n) _special_leds_inc_var_ = n; call Leds.set(_special_leds_inc_var_); 
#define LINC() call Leds.set(++_special_leds_inc_var_);

uint8_t _special_leds_inc_var_ = 0;

/* pinpoint segaults with unbuffered writes */
/* #define SERIOUS_DEBUG(text,len) write(1,text,len); */
#define SERIOUS_DEBUG(text,len)

/* for filtering radio msgs on radios that have channel metrics */
//#define SP_POWER_THRESH
//#define SP_LQI_THRESH

#define RELIABILITY_HACK
//#define RELIABILITY_HACK2
//#define RELIABILITY_HACK3

#endif // __SPSIMDBG_H
