#!/usr/bin/python

import os
from subprocess import call, Popen
from  pdb import set_trace as st

TEMP_CMDS = '.TEMP_CMDS'

class CmdExecutor:
	execid = 0
	def __init__(self):
		self.execid = CmdExecutor.execid
		CmdExecutor.execid += 1
		pass
	def popen(self, cmd, stdout=None, stderr=None, cwd='.', env=None):
		if os.name == 'posix':
			_cmd = cmd
			_cwd = cwd
			fdOut = stdout
			fdErr = stderr
		elif os.name == 'nt':
			# write out a file that is used to execute the desired cmd
			fname = TEMP_CMDS + str(self.execid)
			print fname
			f = open(os.path.join(os.environ['MY_HOME'], fname), 'w')
			print >>f, 'cd `cygpath -u "%s"`' % (os.path.abspath(cwd))
			print >>f, 'pwd'
			for c in cmd: # write out the cmd
				print >>f, c,
			print ''
			f.close()

			_cmd = [os.environ['CYGROOT'] + '/bin/bash', '--login', '-i', fname]
			_cwd = '.' # it is inconsequential when calling from windows
			fdOut = None
			fdErr = None
			
		else:
			raise Exception, 'unsupported platform %s' % (os.name)
		print 'Executing "%s" as "%s"' % (cmd, _cmd)
		p = Popen(_cmd, stdout=fdOut, stderr=fdErr, cwd=_cwd, env=env) #todo add some dots while compiling
		print 'pid = %i' % (p.pid)
		return p
	def popen_win(self, cmd, stdout=None, stderr=None, cwd='.'):
		
		if os.name == 'posix':
			_cmd = ['rxvt', '-e']
			_cmd.extend(cmd)
		else:
			_cmd = cmd
		return self.popen(_cmd, stdout, stderr, cwd)

if os.name == 'nt':
	import win32api
	import win32con
	import win32process
	import win32event
	import win32com.client
	import ctypes
elif os.name == 'posix':
	import signal
	
def killProc(process):
	if os.name == 'nt':
		return SafeTerminateProcess(process.pid)
	elif os.name == 'posix':
		os.kill(process.pid, signal.SIGKILL)
		return True

def getChildrenPidsOfPid(pid):
    print 'getting children of %s' % pid
    wmi = win32com.client.GetObject('winmgmts:')
    children = wmi.ExecQuery('Select * from win32_process where ParentProcessId=%s' % pid)
    pids = []
    for proc in children:
        print 'child: %s %s' % (proc.Name, proc.Properties_('ProcessId'))
        pids.append(proc.Properties_('ProcessId'))
    return pids

def SafeTerminateProcess(pid):
    '''BOOL SafeTerminateProcess(pid),
	originally: (HANDLE hProcess, UINT uExitCode),
    returns non-zero value on success.
    '''
    success = False
    for child in getChildrenPidsOfPid(pid):
        SafeTerminateProcess(child)
        ### this is only for testing, sometimes terminating the children causes  parental suicide
        import time; time.sleep(5)
    print 'trying to terminate pid %s' % pid
    try:
        handle = win32api.OpenProcess(win32con.PROCESS_ALL_ACCESS, False, pid)
    except Exception, e:
        print e
        return
			
    exitcode = win32process.GetExitCodeProcess(handle)
    if exitcode == win32con.STILL_ACTIVE:
        print 'need to terminate pid %s' % pid
        hKernel = win32api.GetModuleHandle("Kernel32")
        procExit = win32api.GetProcAddress(hKernel, "ExitProcess")
        # the following is not (yet?) in win32process:
        hRemoteT = ctypes.windll.kernel32.CreateRemoteThread(handle.handle, None, 0, procExit, ctypes.c_void_p(-1), 0, None)
        if not hRemoteT:
            print 'bad, no thread'
        else:
            print 'waiting after starting remote thread'
            retval = win32event.WaitForSingleObject(handle, 5000) # wait 5 seconds
            if retval == win32con.WAIT_TIMEOUT:
                print 'argh, timeout elapsed'
            win32api.CloseHandle(hRemoteT)
            success = True
    else:
        success = True
        print 'pid %s already dead' % pid
    win32api.CloseHandle(handle)
    print 'success is %s for pid %s' % (success, pid)
    return success
