import cmdexecutor as cmde
from pdb import set_trace as st
import sys
import subprocess
import time

class Connection:
	def __init__(self, connstr):
		self.valid = False
		strs = connstr.split('@')
		if len(strs) == 2 and strs[0] == 'serial':
			strs2 = strs[1].split(':')
			if len(strs2) == 2 and strs2[1] == 'telos':
				self.valid = True
				self.type = strs[0]
				self.port = strs2[0]
				self.portnum = int(self.port[3:])
				self.baud = strs2[1]
	def string(self):
		return '%s@%s:%s' % (self.type, self.port, self.baud)

def printhelp():
	print """
usage: masssf.py [-auto|-moteconfig <MOTECONFIG>] [-sfconfig <SFCONFIG>]
	"""

def parseargs():
	moteconfig = auto = sfconfig = None
	for arg in sys.argv[1:]:
		if arg == '-auto':
			auto = True
			continue
		if arg == '-h':
			printhelp()
			sys.exit(0)
		(key,val) = arg.split('=')
		if key == '-moteconfig':
			moteconfig = val
		elif key == '-sfconfig':
			sfconfig = val
		else:
			raise Exception, 'Invalid arg %s' % (key)
	# prompt for unspecified args
	if moteconfig == None and auto == None:
		moteconfig = raw_input('moteconfig file (e.g. moteconfig.local): ')
	elif moteconfig != None and auto == True:
		raise Exception, 'Both moteconfig and auto cannot be true'
	if sfconfig == None:
		sfconfig = 'sfconfig.local'
	return (moteconfig, auto, sfconfig)

def getmotelist():
	p = subprocess.Popen(['motelist'], shell=True, stdout=subprocess.PIPE)
	out = p.stdout.read()
	lines = out.split('\n')[2:]
	coms = []
	for l in lines:
		strs = l.split()
		if len(strs) > 2:
			coms.append('serial@' + strs[1] + ':telos')
	return coms
	st()

def main():
	(moteconfig, auto, sfconfig) = parseargs()
	if auto:
		f = getmotelist()
	else:
		f = open(moteconfig)
		
	# only accepted "serial@COMXX:telos" for now
	conns = []
	for l in f:
		conn = Connection(l.strip())
		if conn.valid:
			conns.append(conn)
			print "found:", conn.string()
	
	print "PLEASE REMEMBER: AT THE END, PRESS ENTER to kill, not Ctrl-D"
	raw_input("Press ENTER to open a lot of serial forwarders")
	
			

	portnumbase = 7700
	processes = []
	fsfconfig = open(sfconfig, 'w')
	# fout = open('out','w')
	# fout = sys.stdout
	for conn in conns:
		print conn.string()
		portnum = portnumbase + conn.portnum
		ce = cmde.CmdExecutor()
		cmd = ['java', 'net.tinyos.sf.SerialForwarder', '-no-gui',
					 '-comm', conn.string(),
					 '-port', str(portnum)]
    #     p = ce.popen(cmd, stdout=fout, stderr=fout)
		p = ce.popen(cmd)
		print >>fsfconfig, 'sf@localhost:%i' % (portnum)
		processes.append(p)
	fsfconfig.close()

	raw_input("Press ENTER to kill")
	for p in processes:
		print 'killing %i' % (p.pid)
		cmde.killProc(p)

if __name__ == '__main__':
	main()
